//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%3DAF00CC03A7.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3DAF00CC03A7.cm

//## begin module%3DAF00CC03A7.cp preserve=no
//## end module%3DAF00CC03A7.cp

//## Module: PlotResiduals%3DAF00CC03A7; Package body
//## Subsystem: XSPlot::Commands%3DA1AFD101BF
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSPlot/Commands/PlotResiduals.cxx

//## begin module%3DAF00CC03A7.additionalIncludes preserve=no
//## end module%3DAF00CC03A7.additionalIncludes

//## begin module%3DAF00CC03A7.includes preserve=yes
#include <XSPlot/Plot/CreateBinnedPlotGroups.h>
#include <XSPlot/Plot/PlotGroup.h>
#include <XSPlot/Plot/PlotSettings.h>
#include <XSPlot/Plot/PlotStyle.h>
#include <XSPlot/Plot/PlotTypes.h>
//## end module%3DAF00CC03A7.includes

// PlotResiduals
#include <XSPlot/Commands/PlotResiduals.h>
//## begin module%3DAF00CC03A7.declarations preserve=no
//## end module%3DAF00CC03A7.declarations

//## begin module%3DAF00CC03A7.additionalDeclarations preserve=yes
//## end module%3DAF00CC03A7.additionalDeclarations


// Class PlotResiduals 

PlotResiduals::PlotResiduals()
  //## begin PlotResiduals::PlotResiduals%3DAEFC3703D8_const.hasinit preserve=no
  //## end PlotResiduals::PlotResiduals%3DAEFC3703D8_const.hasinit
  //## begin PlotResiduals::PlotResiduals%3DAEFC3703D8_const.initialization preserve=yes
  : PlotCommand("residuals", new CreateBinnedPlotGroups(false,false))
  //## end PlotResiduals::PlotResiduals%3DAEFC3703D8_const.initialization
{
  //## begin PlotResiduals::PlotResiduals%3DAEFC3703D8_const.body preserve=yes
   isDataRequired(true);
   isActiveModelRequired(true);
   isDivisibleByArea(true);
   addCompLevel(0);
   isBackgroundApplicable(false);
   
   PlotAttributes styles;
   styles.symbolStyle = PlotCommand::standardDataStyle();
   styles.lineStyle = PlotStyle::NONE;
   setStyleMap(PlotStyle::DATA, styles);
  //## end PlotResiduals::PlotResiduals%3DAEFC3703D8_const.body
}


PlotResiduals::~PlotResiduals()
{
  //## begin PlotResiduals::~PlotResiduals%3DAEFC3703D8_dest.body preserve=yes
  //## end PlotResiduals::~PlotResiduals%3DAEFC3703D8_dest.body
}



//## Other Operations (implementation)
void PlotResiduals::manipulate (std::vector<PlotGroup*>& plotGroups, const PlotSettings& settings)
{
  //## begin PlotResiduals::manipulate%4B3275FE00DB.body preserve=yes
   for (size_t i=0; i<plotGroups.size(); ++i)
   {
      PlotGroup* pg = plotGroups[i];
      const size_t nPts = pg->n;
      std::vector<Real>& data  = pg->yData.data;
      const std::vector<Real>& model  = pg->model[0].data;
      for (size_t j=0; j<nPts; ++j)
      {
         data[j] -= model[j];
      }
      
   }
  //## end PlotResiduals::manipulate%4B3275FE00DB.body
}

void PlotResiduals::setRanges (std::vector<PlotGroup*>& plotGroups, const PlotSettings& settings)
{
  //## begin PlotResiduals::setRanges%4B32760402AE.body preserve=yes
   Real xlow=0.0, xhigh=0.0;
   PlotGroupCreator::determineXRange(plotGroups,&xlow,&xhigh);
  
   PlotRange& rangeVals = rangeSettings();
   rangeVals.ranges.x1 = xlow;
   rangeVals.ranges.x2 = xhigh;
   if (settings.xOption() == CHANNELS)
      rangeVals.xScaleType = PlotStyle::LINEAR;
   else 
      rangeVals.xScaleType = settings.xLog() ? PlotStyle::LOG :
                PlotStyle::LINEAR;
                
   rangeVals.useRangeFlags = PlotStyle::XMIN + PlotStyle::XMAX;
   
   rangeVals.horizontalLine.first = true;
   rangeVals.horizontalLine.second = 0.0;
  //## end PlotResiduals::setRanges%4B32760402AE.body
}

void PlotResiduals::makeLabels (const PlotSettings& settings, StandardLabels& labels) const
{
  //## begin PlotResiduals::makeLabels%4B3276090355.body preserve=yes
   string xKey(settings.makeXOptionDependentLabel(labels.x));
   labels.title = settings.lookupLabelName("t:residuals");
   
   string fullKey(string("y:data") + xKey.substr(1));
   string yLabel = settings.lookupLabelName(fullKey);
   settings.insertUnitLabel(yLabel,true);
   labels.y = yLabel;
   
   if (settings.divideByArea())
   {
      string inverseArea = settings.lookupLabelName("y:suffix:area");
      yLabel += " ";
      yLabel += inverseArea;
      labels.y = yLabel;       
   }
  //## end PlotResiduals::makeLabels%4B3276090355.body
}

std::vector<PlotGroup*> PlotResiduals::makePlotGroups (const PlotSettings& settings, const std::vector<const PlotGroup*>& donatedPlotGroups)
{
  //## begin PlotResiduals::makePlotGroups%4B633CFD0117.body preserve=yes
   // Plot residuals should show different behavior if following an icounts 
   // or data plot.  For example, following icounts it will show residuals 
   // of the cumulative totals.  To do this, it must make use of the
   // previous plot's donated plot groups.
   std::vector<PlotGroup*> newGroups;
   if (donatedPlotGroups.size())
   {
      for (size_t i=0; i<donatedPlotGroups.size(); ++i)
      {
         const PlotGroup* origGroup = donatedPlotGroups[i];
         PlotGroup* newGroup = new PlotGroup(origGroup->n, 1);
         
         // Need only the x, y, and model[0] vectors from the original group.
         newGroup->xAxis = origGroup->xAxis;
         newGroup->yData = origGroup->yData;
         newGroup->model[0] = origGroup->model[0];
         newGroup->copyAttributes(*origGroup);
         newGroups.push_back(newGroup);
      }
   }
   else
      newGroups = plotGroupStrategy()->createPlotGroups(settings);
    return newGroups;
 //## end PlotResiduals::makePlotGroups%4B633CFD0117.body
}

// Additional Declarations
  //## begin PlotResiduals%3DAEFC3703D8.declarations preserve=yes
  //## end PlotResiduals%3DAEFC3703D8.declarations

//## begin module%3DAF00CC03A7.epilog preserve=yes
//## end module%3DAF00CC03A7.epilog
